//+------------------------------------------------------------------+
//|                                                         test.mq4 |
//|                                           Copyright  2009, alsu |
//|                                                 alsufx@gmail.com |
//+------------------------------------------------------------------+

#include <exchng.mqh>

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Red

//---- buffers
double ATRCopyBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
string atr_buffer,buffers[];
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ATRCopyBuffer);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

   int found=FindBuffers("ATR",0,"",0,buffers);     //searching for descriptors among global variables
   if(found>0) atr_buffer=buffers[0];                 //have they been found? Store the pointer in the variable
   else atr_buffer="";
   int   i;

   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
   if(counted_bars==0) limit--;
   
//----
   for(i=limit;i>=0;i--)
     {
      if(atr_buffer=="") break;
      ATRCopyBuffer[i]=GetIndicatorValue(atr_buffer,i);    //now, we easily can receive the data
      SetIndicatorValue(atr_buffer,i,i);                   //and write it as well
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+
